# -*- coding: euc-jp -*-
require "numru/ggraph"
include NumRu


#vname = 'Height'
#ncfn  = '../util_timemean-2012-11-02/out/U.nc'
#ncfn  = '/hagukumu/yot/work/dcmodel/dcpam/dcpam5-2013-03-02_src-20130302-CalModForAMIP_CalcForSample_snpack_mpi_whale03-1/practice/Earth_T42L48_AdvSemiLag_CldAdv_CldLT0420s_WithDCA_dt05min_196901-197812/util_s2p-2013-05-24/out/Height.nc'

plev =  10e2
plev = 100e2
plev = 500e2
plev = 700e2

dir   = ARGV[0]
vname = ARGV[1]
t     = ARGV[2].to_i

if vname == "VIH2OCld"
  vname1 = 'VIH2OLiq'
  ncfn  = dir + '/' + vname1 + '.nc'
  gphys1 = GPhys::NetCDF_IO.open(ncfn, vname1)
  vname2 = 'VIH2OLiq'
  ncfn  = dir + '/' + vname2 + '.nc'
  gphys2 = GPhys::NetCDF_IO.open(ncfn, vname2)
  gphys = gphys1 + gphys2
else
  ncfn  = dir + '/' + vname + '.nc'
  gphys = GPhys::NetCDF_IO.open(ncfn, vname)
end

time = gphys.coord('time').val
#tm = gphys.shape[3]

#gphys = gphys.cut('time'=>time[t]).cut('level'=>plev).cut('lat'=>0..90)
gphys = gphys.cut('time'=>time[t]..time[t])

#gphys = gphys * 1.0e-3
#gphys.units = 'km'

def ext_lonlat_array( gphys )
  # extend an array
  lon  = gphys.coord('lon' ).val
  lat  = gphys.coord('lat' ).val
  time = gphys.coord('time').val
  array = gphys.val
  vname = gphys.name

  ext_lon   = NArrayMiss.float( lon.size+1 )
  ext_lat   = NArrayMiss.float( lat.size+2 )
  ext_array = NArrayMiss.float( lon.size+1, lat.size+2, time.size )
  ext_lon[0..lon.size-1] = lon[0..lon.size-1]
  ext_lon[-1] = 360.0
  ext_lat[1..lat.size] = lat[0..lat.size-1]
  ext_lat[0] = -90.0
  ext_lat[-1] =  90.0
  ext_array[0..lon.size-1,1..lat.size,true] = array[0..lon.size-1,0..lat.size-1,true]
  ext_array[0..lon.size-1,0,true] = array[0..lon.size-1,1,true].mean(0)
  ext_array[0..lon.size-1,-1,true] = array[0..lon.size-1,-2,true].mean(0)
  ext_array[-1,true,true] = ext_array[0,true,true]

  va_ext_lon = VArray.new( ext_lon, {"long_name"=>"lon", "units"=>"degrees_east"}, "lon" )
  ax_ext_lon = Axis.new.set_pos(va_ext_lon)
  va_ext_lat = VArray.new( ext_lat, {"long_name"=>"lat", "units"=>"degrees_north"}, "lat" )
  ax_ext_lat = Axis.new.set_pos(va_ext_lat)
  if gphys.get_att('missing_value').nil?
    va_ext_array = VArray.new( ext_array, {"long_name"=>vname, "units"=>"1"}, vname )
  else
    rmiss = gphys.get_att('missing_value')[0]
    va_ext_array = VArray.new( ext_array, {"long_name"=>vname, "units"=>"1", "missing_value"=>[rmiss]}, vname )
  end
  gphys_out = GPhys.new( Grid.new(ax_ext_lon,ax_ext_lat,gphys.axis('time')), va_ext_array )

  return gphys_out
end

gphys = ext_lonlat_array( gphys )
gphys = gphys.cut('time'=>time[t])


rmiss = gphys.get_att('missing_value')[0]
DCL.glpset('lmiss',true)
DCL.glpset('rmiss',rmiss)


if plev == 10e2
  # for 10 hPa
  levels = [26.0,26.2,26.4,26.6,26.8,27.0,27.2,27.4,27.6,27.8,28.0,28.2,28.4,28.6,28.8,29.0,29.2,29.4,29.6,29.8,30.0,30.2,30.4,30.6,30.8,31.0,31.2,31.4,31.6,31.8,32.0]
  patterns = [10999,12999,15999,17999,20999,22999,25999,27999,30999,32999,35999,37999,40999,42999,45999,47999,50999,52999,55999,57999,60999,62999,65999,67999,70999,72999,75999,80999,85999,90999,92999,95999]
elsif plev == 50e2
  # for 50 hPa
  levels = [18.0,18.2,18.4,18.6,18.8,19.0,19.2,19.4,19.6,19.8,20.0,20.2,20.4,20.6,20.8,21.0,21.2,21.4,21.6,21.8,22.0]
  patterns = [10999,12999,15999,20999,25999,30999,32999,35999,40999,45999,50999,55999,60999,65999,70999,72999,75999,80999,85999,90999,92999,95999]
elsif plev == 500e2
  levels = [26.0,26.2,26.4,26.6,26.8,27.0,27.2,27.4,27.6,27.8,28.0,28.2,28.4,28.6,28.8,29.0,29.2,29.4,29.6,29.8,30.0,30.2,30.4,30.6,30.8,31.0,31.2,31.4,31.6,31.8,32.0]
  for i in 0..(levels.length-1)
    levels[i] = levels[i] - 26.0
    levels[i] = levels[i] / 2.0
    levels[i] = levels[i] + 4.5
  end
  patterns = [10999,12999,15999,17999,20999,22999,25999,27999,30999,32999,35999,37999,40999,42999,45999,47999,50999,52999,55999,57999,60999,62999,65999,67999,70999,72999,75999,80999,85999,90999,92999,95999]
end

if vname == "QH2OVap"
  # Earth QH2OVap
  levels = [1e-5, 0.5e-3, 1.0e-3, 1.5e-3, 2.0e-3, 2.5e-3, 3.0e-3, 3.5e-3, 4.0e-3, 4.5e-3, 5.0e-3, 5.5e-3, 6.0e-3, 6.5e-3, 7.0e-3, 7.5e-3, 8.0e-3, 8.5e-3, 9.0e-3, 9.5e-3, 10.0e-3]
  patterns = [12999,15999,17999,20999,25999,27999,30999,35999,40999,50999,60999,65999,70999,75999,80999,85999,90999,95999,97999,99999]
elsif vname == "VIH2OVap"
  # Earth VIH2OVap
  gphys.long_name = "Precipitable water"
  gphys.units = "kg m-2"
  levels = [1e-1, 0.5e1, 1.0e1, 1.5e1, 2.0e1, 2.5e1, 3.0e1, 3.5e1, 4.0e1, 4.5e1, 5.0e1, 5.5e1, 6.0e1, 6.5e1, 7.0e1, 7.5e1, 8.0e1, 8.5e1, 9.0e1, 9.5e1, 10.0e1]
  for i in 0..levels.size-1
    #  levels[i] = levels[i] * 5e-3
    levels[i] = levels[i] * 7.5e-1
  end
  patterns = [1,12999,15999,17999,20999,22999,25999,27999,30999,35999,40999,50999,60999,65999,70999,75999,80999,85999,90999,92999,95999,97999]
elsif vname == "VIH2OLiq" || vname == "VIH2OSol" || vname == "VIH2OCld"
  # Earth VIH2OLiq, Sol
  if vname == "VIH2OLiq"
    gphys.long_name = "LWP"
  elsif vname == "VIH2OSol"
    gphys.long_name = "IWP"
  elsif vname == "VIH2OCld"
    gphys.long_name = "LWP + IWP"
  end
  gphys.units = "kg m-2"
  levels = [1e-1, 0.5e1, 1.0e1, 1.5e1, 2.0e1, 2.5e1, 3.0e1, 3.5e1, 4.0e1, 4.5e1, 5.0e1, 5.5e1, 6.0e1, 6.5e1, 7.0e1, 7.5e1, 8.0e1, 8.5e1, 9.0e1, 9.5e1, 10.0e1]
  for i in 0..levels.size-1
    #  levels[i] = levels[i] * 5e-3
    levels[i] = levels[i] * 7.5e-3
  end
  patterns = [1,12999,15999,17999,20999,22999,25999,27999,30999,35999,40999,50999,60999,65999,70999,75999,80999,85999,90999,92999,95999,97999]
elsif vname == "SurfTemp"
  # Earth SurfTemp
  gphys.long_name = "Surface Temperature"
#    gphys.units = "K"
  levels = [200, 205, 210, 215, 220, 225, 230, 235, 240, 245, 250, 255, 260, 265, 270, 275, 280, 285, 290, 295, 300, 305, 310]
  patterns = [1,12999,15999,17999,20999,22999,25999,27999,30999,32999,35999,40999,45999,50999,60999,65999,70999,75999,80999,85999,90999,92999,95999,97999]
end


#DCL.sgscmn(14) # blue-white-red


#< DCLΥץ >
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2˲ʬ, 'y'=yoko: 墪墪...
DCL.sgpset('lcntl', false)   # ʸᤷʤ
DCL.sgpset('lfull',true)     # ɽ
DCL.uzfact(0.75)             # ɸʸ󥵥 0.75 
DCL.sgpset('lfprop',true)    # ץݡʥեȤȤ

#< GGraph ˤ  >
GGraph.set_fig 'itr'=>10, 'viewport'=>[0.0,0.96,0.0,0.75], 'window'=>[0,360,-90,90]
GGraph.set_map 'coast_world'=>true, 'grid'=>false
#GGraph.set_axes('xlabelint'=>90)
#GGraph.set_axes('ylabelint'=>30)
GGraph.set_axes 'xlabelint'=>720, 'xside'=>""
GGraph.set_axes 'ylabelint'=>360, 'yside'=>""

#DCL::uestln(patterns)
#DCL::uxsttl('B', '', 0.0)
#DCL::uwsgxa(gphys.coord('lon').val)
#DCL::uwsgya(gphys.coord('lat').val)
#DCL::uetone(gphys.val)

#gphys_out = gphys.copy
gphys.coord('lon').long_name = ''
gphys.coord('lon').units = ''

GGraph.tone gphys, true, 'lev'=>levels, 'pat'=>patterns, 'annotate'=>false


DCL.grcls
